diff --git a/libr/util/calc.c b/libr/util/calc.c
index ff26050870e..5eddd3f1370 100644
--- a/libr/util/calc.c
+++ b/libr/util/calc.c
@@ -243,7 +243,7 @@ static int cin_get_num(RNum *num, RNumCalc *nc, RNumCalcValue *n) {
 			str[i++] = c;
 		}
 	}
-	str[i] = 0;
+	str[i - 1] = 0;
 	*n = Nset (r_num_get (num, str));
 	if (IS_DIGIT (*str) && strchr (str, '.')) {
 		if (sscanf (str, "%lf", &d) < 1) {
